#ifndef _AISL_BUFFER_H_
#define _AISL_BUFFER_H_

#include <sys/types.h>


struct buffer
{
  char    * data;
  int32_t   size;
  int32_t   length;
};

typedef struct buffer * buffer_t;


int32_t
buffer_init( buffer_t buffer, int32_t size );


void
buffer_release( buffer_t buffer );


int32_t
buffer_clear( buffer_t self, int32_t to_alloc );


int32_t
buffer_insert( buffer_t self, int32_t offset, const char * data, int32_t size );


int32_t
buffer_add( buffer_t self, const char * data, int32_t size );


int32_t
buffer_shift( buffer_t self, int32_t size );


#endif
