#ifndef AISL_LIST_H_3223EF5C_CCF2_4D7C_8A3B_8BAF122E473F
#define AISL_LIST_H_3223EF5C_CCF2_4D7C_8A3B_8BAF122E473F

#include <stdint.h>

#define LIST_NAN (~0)

struct list
{
    void   ** list;
    size_t    size;
    size_t    count;
};

typedef struct list * list_t;


typedef void (* list_destructor_t)(void * list_item);

#define list_index(self, index) (self->list[index])

list_t
list_new(int size);

void
list_free(list_t self, list_destructor_t destructor);

int
list_insert( list_t self, void * item, int position );

int
list_append(list_t self, void * item);


void
list_remove( list_t self, void * item );


void *
list_remove_index( list_t self, int index );


void
list_set_item(list_t self, int index, void * value);


#endif /* !AISL_LIST_H */
